﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr199_1
{
    // Структура: 
    struct MyNum {
        // Закрытое целочисленное поле: 
        private int number;
        // Конструктор: 
        public MyNum(int n) {
            // Значение поля: 
            number = n;
        }
        // Метод для вычисления суммы экземпляра структуры 
        // и числа:
        public static int operator+(MyNum A, int n) { 
            return !A + n;
        }
        // Метод для вычисления суммы числа и 
        // экземпляра структуры: 
        public static int operator+(int n, MyNum A) { 
            return A + n;
        }
        // Метод для вычисления суммы двух экземпляров 
        // структуры:
        public static int operator+(MyNum A, MyNum B) { 
            return !A + !B;
        }
        // Метод для унарного оператора: 
        public static int operator!(MyNum A) { 
            return A.number;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание экземпляров структуры:
            MyNum A = new MyNum(100);
            MyNum B = new MyNum(200);
            // Использование операторных методов для вычисления 
            // значения выражений:
            Console.WriteLine("A: {0}", !A);
            Console.WriteLine("B: {0}", !B);
            Console.WriteLine("A + B: {0}", A + B);
            Console.WriteLine("A + 10: {0}", A + 10);
            Console.WriteLine("20 + B: {0}", 20 + B);
            // Задержка:
            Console.ReadLine();
        }
    }
}
